import React from 'react';
import { useInfiniteScroll } from './useInfiniteScroll';
import { FixedContainer, RootFlexContainer, ScrollableContainer, } from './styles';
import { DefaultListLoading } from './DefaultLoading';
import { DefaultListLoadMore } from './DefaultLoadMore';
import { useConfirmLoading } from './useConfirmLoading';
export var LazyList = function (_a) {
    var hasNextPage = _a.hasNextPage, loading = _a.loading, _b = _a.items, items = _b === void 0 ? [] : _b, loadNextPage = _a.loadNextPage, threshold = _a.threshold, withPrefetchedData = _a.withPrefetchedData, registerScrollableList = _a.registerScrollableList, _c = _a.renderRoot, Root = _c === void 0 ? RootFlexContainer : _c, renderRow = _a.renderRow, _d = _a.renderLoading, Loading = _d === void 0 ? DefaultListLoading : _d, _e = _a.renderLoadMore, LoadMore = _e === void 0 ? DefaultListLoadMore : _e, _f = _a.shouldConfirmInfiniteLoading, shouldConfirmInfiniteLoading = _f === void 0 ? false : _f;
    var confirmLoading = useConfirmLoading({
        loading: loading,
        shouldConfirmInfiniteLoading: shouldConfirmInfiniteLoading,
        withPrefetchedData: withPrefetchedData,
        hasNextPage: hasNextPage,
    });
    var _g = useInfiniteScroll({
        loading: loading,
        hasNextPage: hasNextPage,
        onLoadMore: loadNextPage,
        registerScrollableList: registerScrollableList,
        threshold: threshold,
        withPrefetchedData: withPrefetchedData,
        confirmLoading: confirmLoading,
    }), infiniteRef = _g.ref, showLoadMore = _g.showLoadMore;
    return (React.createElement(Root, null,
        React.createElement(FixedContainer, { ref: infiniteRef },
            React.createElement(ScrollableContainer, null,
                items.map(renderRow),
                loading && React.createElement(Loading, null),
                showLoadMore && React.createElement(LoadMore, { loadNextPage: loadNextPage })))));
};
