var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
import React from 'react';
import styled from 'styled-components';
import defaultTheme from "../../theme";
import { Text, Header } from "../Text";
import { Icon } from "../Icon";
/**
 * MessageWrapper
 */
var MessageWrapper = styled.div.withConfig({ displayName: "MessageWrapper", componentId: "sc-1igyx94" })(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  display: flex;\n  justify-content: space-between;\n  align-items: center;\n"], ["\n  display: flex;\n  justify-content: space-between;\n  align-items: center;\n"])));
/**
 * MessageHeader
 */
var MessageHeader = styled(Header).withConfig({ displayName: "MessageHeader", componentId: "sc-rf82og" })(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  padding-bottom: 0.25rem;\n  font-weight: 700;\n"], ["\n  padding-bottom: 0.25rem;\n  font-weight: 700;\n"])));
/**
 * MessageContent
 */
var MessageContent = styled(Text).withConfig({ displayName: "MessageContent", componentId: "sc-brrw9w" })({
    margin: 0,
});
export var Message = styled(function (_a) {
    var header = _a.header, content = _a.content, icon = _a.icon, onDismiss = _a.onDismiss, className = _a.className;
    var headerNode = header && (React.createElement(MessageHeader, { as: "h2" }, header));
    var contentNode = content && React.createElement(MessageContent, null, content);
    if (Icon) {
        return (React.createElement("div", { className: className },
            React.createElement(MessageWrapper, null,
                icon && React.createElement(Icon, { name: icon, className: "icon", size: "huge" }),
                React.createElement("div", { className: "content" },
                    headerNode,
                    contentNode),
                onDismiss && (React.createElement(Icon, { color: "white", onClick: onDismiss, name: "times", size: "huge" })))));
    }
    return (React.createElement("div", { className: className },
        headerNode,
        contentNode));
}).withConfig({ displayName: "Message", componentId: "sc-2mma60" })({
    position: 'relative',
    minHeight: '1em',
    padding: '1em 1.5em',
    lineHeight: '1.5em',
    maxHeight: '150px',
    textAlign: 'left',
}, 
// Handle message colours
function (_a) {
    var theme = _a.theme, info = _a.info, success = _a.success, negative = _a.negative, error = _a.error, warning = _a.warning;
    var isNegative = negative || error;
    var backgroundColor;
    if (info) {
        backgroundColor = theme.colors.blue.default;
    }
    else if (success) {
        backgroundColor = theme.colors.green.default;
    }
    else if (isNegative) {
        backgroundColor = theme.colors.red.default;
    }
    else if (warning) {
        backgroundColor = theme.colors.orange.default;
    }
    else {
        backgroundColor = theme.greyscale.dark;
    }
    return {
        color: theme.colors.white.default,
        backgroundColor: backgroundColor,
        '& > .icon': {
            color: theme.colors.white.default,
        },
    };
}, 
// Handle icon
function (_a) {
    var icon = _a.icon;
    return icon
        ? {
            display: 'flex',
            alignItems: 'center',
            '& > .content': {
                display: 'block',
                flex: '1 1 auto',
                verticalAlign: 'middle',
            },
            '& > .icon': {
                display: 'block',
                flex: '0 0 auto',
                opacity: 0.8,
                marginRight: '0.6em',
            },
        }
        : null;
});
Message.defaultProps = {
    theme: defaultTheme,
};
var templateObject_1, templateObject_2;
