import React, { useState } from 'react';
import { Icon, Tooltip } from "./..";
import { useOnClickOutside } from "../../utils";
import { OptionsControlWrapper, OptionsControlList, OptionsControlListItem, OptionsControlListItemLabel, OptionsControlButton, } from './styles';
var DEFAULT_OPEN_STATE = {
    open: false,
    opening: false,
    closing: false,
};
export var OptionsControl = function (_a) {
    var _b = _a.disabled, disabled = _b === void 0 ? false : _b, options = _a.options, placeholder = _a.placeholder;
    var _c = useState(DEFAULT_OPEN_STATE), openState = _c[0], setOpenState = _c[1];
    var closing = openState.closing, open = openState.open, opening = openState.opening;
    var rotateIcon = !open || closing;
    var timeoutRef = React.useRef(0);
    var outRef = useOnClickOutside(function () {
        return setOpenState(DEFAULT_OPEN_STATE);
    });
    var resetOpenState = function () { return setOpenState(DEFAULT_OPEN_STATE); };
    var handleOpen = function () {
        if (timeoutRef.current) {
            clearTimeout(timeoutRef.current);
            timeoutRef.current = 0;
        }
        if (open) {
            setOpenState({ closing: true, open: true, opening: false });
            // @ts-ignore
            timeoutRef.current = setTimeout(resetOpenState, 300);
        }
        else {
            setOpenState({ closing: false, open: true, opening: true });
            // @ts-ignore
            timeoutRef.current = setTimeout(function () { return setOpenState({ closing: false, open: true, opening: false }); }, 500);
        }
    };
    return (React.createElement(OptionsControlWrapper, { ref: outRef },
        React.createElement(OptionsControlList, { opening: opening, closing: closing }, open &&
            options.map(function (_a) {
                var active = _a.active, id = _a.id, label = _a.label, onClick = _a.onClick;
                var handleClick = function () {
                    resetOpenState();
                    onClick();
                };
                return (React.createElement(OptionsControlListItem, { key: id, onClick: handleClick, active: active },
                    React.createElement(Tooltip, { data: label, placing: "left", textOverflow: true },
                        React.createElement(OptionsControlListItemLabel, null, label)),
                    active && React.createElement(Icon, { name: "check", size: "small", fitted: true })));
            })),
        React.createElement(OptionsControlButton, { onClick: handleOpen, disabled: disabled, open: open && !closing },
            React.createElement(OptionsControlListItemLabel, null, placeholder),
            React.createElement(Icon, { name: "caret-up", inheritColor: true, fitted: true, rotate: rotateIcon }))));
};
