import { DefaultTheme } from 'styled-components';
export declare type Breakpoint = keyof DefaultTheme['breakpoints'] | number;
/**
 * Any screen width up to the selected breakpoint
 * @param bp Select breakpoint to go up to
 */
export declare const above: (bp: Breakpoint) => ({ theme }: {
    theme: DefaultTheme;
}) => string;
/**
 * Any screen width down to the selected breakpoint
 * @param bp Select breakpoint to go down to
 */
export declare const below: (bp: Breakpoint) => ({ theme }: {
    theme: DefaultTheme;
}) => string;
/**
 * Any screen width between the selected breakpoints
 * @param a Select start breakpoint
 * @param b Select end breakpoint to go up to
 */
export declare const between: (min: Breakpoint, max: Breakpoint) => ({ theme, }: {
    theme: DefaultTheme;
}) => string;
/**
 * Any screen size between medium
 */
export declare const sm: ({ theme }: {
    theme: DefaultTheme;
}) => string;
/**
 * Any screen size between medium and large
 */
export declare const md: ({ theme, }: {
    theme: DefaultTheme;
}) => string;
/**
 * Any screen size between large and extra large
 */
export declare const lg: ({ theme, }: {
    theme: DefaultTheme;
}) => string;
/**
 * Any screen size above extra large
 */
export declare const xl: ({ theme }: {
    theme: DefaultTheme;
}) => string;
