var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
import { difference } from 'ramda';
export function getReviewerIds(sme, session, auditEnabled) {
    if (auditEnabled) {
        return sme ? session.auditReviewerIds : session.auditKiReviewerIds;
    }
    return sme ? session.teachingReviewerIds : session.conversionReviewerIds;
}
export function getParticipantIds(sme, session) {
    return sme
        ? session.teachingReviewParticipantIds
        : session.conversionReviewParticipantIds;
}
export function isOwner(sme, currentUserId, _a) {
    var teachingOwnerId = _a.teachingOwnerId, conversionOwnerId = _a.conversionOwnerId;
    return sme
        ? teachingOwnerId === currentUserId
        : conversionOwnerId === currentUserId;
}
export function isReviewer(currentUserId, reviewerIds) {
    return (reviewerIds && reviewerIds.length > 0 && reviewerIds.includes(currentUserId));
}
export function isParticipantInReview(currentUserId, participantIds) {
    return (participantIds &&
        participantIds.length > 0 &&
        participantIds.includes(currentUserId));
}
export function isReviewRequested(reviewerIds) {
    return Boolean(reviewerIds && reviewerIds.length > 0);
}
export function allReviewersAreParticipants(reviewerIds, participantIds) {
    return Boolean(reviewerIds &&
        reviewerIds.length > 0 &&
        participantIds &&
        participantIds.length > 0 &&
        equalElements(participantIds, reviewerIds));
}
function equalElements(participantIds, reviewerIds) {
    var participantIdsCopy = typeof participantIds === 'string' ? [participantIds] : __spreadArray([], participantIds);
    var reviewerIdsCopy = typeof reviewerIds === 'string' ? [reviewerIds] : __spreadArray([], reviewerIds);
    var diff = difference(reviewerIdsCopy, participantIdsCopy);
    return diff.length === 0;
}
